testeParB <- function(data=NULL, gLabelID="GeneName",
sLabelID="Classification", geneGrp=NULL, path=NULL, samples=NULL,
type="Rpearson", bRep=1000, ...) {

    ## removing genes and samples not named or NA from the data object
    removeNaNames(data, gLabelID=gLabelID,sLabelID=sLabelID)

    genes <-getGenes(data, gLabelID=gLabelID, geneGrp=geneGrp, path=path)
   
	geneA= "IGF1R"
	geneB= "OPA1"

    table <- relNetworkBuildTable(data,gLabelID = gLabelID,sLabelID=sLabelID,samples = samples,
type=type, geneA= geneA, geneB=geneB,NULL, genes = genes,processType="B" ) 

	table = simpleNaFilter(table)
	
	result <- relNetworkBWrite(data, gLabelID ,sLabelID, samples = samples,
type, bRep, geneA= geneA, geneB=geneB, result=NULL, genes,tableTmp = table) 
	
		
	geneA= "IGF1R"
	geneB= "CFLAR"
	
    table <- relNetworkBuildTable(data,gLabelID = gLabelID,sLabelID=sLabelID,samples = samples,
type=type, geneA= geneA, geneB=geneB,table, genes = genes, processType="B" ) 
	
	table = simpleNaFilter(table)
	
	result <- relNetworkBWrite(data, gLabelID ,sLabelID, samples = samples,
type, bRep, geneA= geneA, geneB=geneB, result, genes,tableTmp = table) 
	
	
  return(result)
    
}

testeTodosB <- function(data=NULL, gLabelID="GeneName",
sLabelID="Classification", geneGrp=NULL, path=NULL, samples=NULL,
type="Rpearson", bRep=1000, ...) {

    ## removing genes and samples not named or NA from the data object
    removeNaNames(data, gLabelID=gLabelID,sLabelID=sLabelID)

    genes <-getGenes(data, gLabelID=gLabelID, geneGrp=geneGrp, path=path)
   
	geneA= NULL
	geneB= NULL

    table <- relNetworkBuildTable(data,gLabelID = gLabelID,sLabelID=sLabelID,samples = samples,
type=type, geneA= geneA, geneB=geneB,NULL, genes = genes,processType="B" ) 


	##table = simpleNaFilter(table)
	
	result <- relNetworkBWrite(data, gLabelID ,sLabelID, samples = samples,
type, bRep, geneA= geneA, geneB=geneB, result=NULL, genes,tableTmp = table) 

	return(result)
}

testeTodosParB <- function(data=NULL, gLabelID="GeneName",
sLabelID="Classification", geneGrp=NULL, path=NULL, samples=NULL,
type="Rpearson", bRep=1000, ...) {
	
	result = NULL
	
    ## removing genes and samples not named or NA from the data object
    removeNaNames(data, gLabelID=gLabelID,sLabelID=sLabelID)

    genes <-getGenes(data, gLabelID=gLabelID, geneGrp=geneGrp, path=path)
   
	
	 for(i in unique(genes)) {
		for(j in unique(genes)){
			if( j > i){

			    table <- relNetworkBuildTable(data,gLabelID = gLabelID,sLabelID=sLabelID,samples = samples,
type=type, geneA= i, geneB=j,NULL, genes = genes,processType="B" ) 

				##table = simpleNaFilter(table)
				
				result <- relNetworkBWrite(data, gLabelID ,sLabelID, samples = samples,
type, bRep, geneA= i, geneB=j, result, genes,tableTmp = table) 
			}
		}
	}

  return(result)
    
}