relNetworkBWrite <- function(data=NULL, gLabelID = "GeneName",sLabelID="Classification", samples=NULL,
type="Rpearson", bRep=1000, geneA=NULL, geneB=NULL, result=NULL, genes=NULL, tableTmp=NULL, ...) {
	
	
	 if(!(type %in% c("Rpearson", "pearson", "kendall", "spearman", "MI")))
        stop("Parameter 'type' must be 'Rpearson', 'pearson', 'kendall',
        'spearman' or 'MI'.")
		
	
	allSamples <- getLabels(data, sLabelID)
	
	##  Getting the first 2 sample types to use in case of NULL samples parameter
    if(is.null(samples))
		samples <- unique(allSamples)[1]
    
	
	if(is.null(result)){
	
		corObj <- matrix(,length(unique(genes)),length(unique(genes)),TRUE)
		rownames(corObj) <- unique(genes)
		colnames(corObj) <- unique(genes)
					
		pValue <- matrix(,length(unique(genes)),length(unique(genes)),TRUE)
		rownames(pValue) <- unique(genes)
		colnames(pValue) <- unique(genes)
		
		bootM <- matrix(,length(unique(genes)),length(unique(genes)),TRUE)
		rownames(bootM) <- unique(genes)
		colnames(bootM) <- unique(genes)
		
		## Picking R and packages version information
		tmp <- sessionInfo()
		vInfo <- list()
		vInfo$R.version <- tmp$R.version$version.string
		vInfo$BasePacks <- tmp$basePkgs
		tmp1 <- NULL
		for (i in 1:length(tmp$otherPkgs))
			tmp1 <- c(tmp1, paste(tmp$otherPkgs[[i]]$Package, "version",
			tmp$otherPkgs[[i]]$Version))

		vInfo$AddPacks <- tmp1

		## Defining the object to return
		result <- new("maigesRelNetB", Corr=corObj, Pval=pValue,
		maxB=bootM, Date=date(), type=paste(samples, collapse=", "),
		Slabel=sLabelID, V.info=vInfo)
	}
	

	
	## Finding indexes of the samples specified and respective lengths
	sample1 <- which(colnames(tableTmp) %in% samples)
	##n1 <- length(sample1)
	
	corObjTmp <- corCalc(type, tableTmp, sample1)
	pValueTmp <- pValCalc(type , tableTmp, sample1, bRep)
	bootMTmp <- bootMCalc(type, tableTmp, sample1, bRep)
	
	if(is.null(geneA) & is.null(geneB)){
		result@Corr = corObjTmp
		result@Pval = pValueTmp
		result@maxB = bootMTmp
		}
	else{
		result@Corr[geneA,geneA] <-  corObjTmp[1,1]
		result@Corr[geneA,geneB] <-  corObjTmp[1,2]
		result@Corr[geneB,geneA] <-  corObjTmp[2,1]
		result@Corr[geneB,geneB] <-  corObjTmp[2,2]
		
		result@Pval[geneA,geneA] <-  pValueTmp[1,1]
		result@Pval[geneA,geneB] <-  pValueTmp[1,2]
		result@Pval[geneB,geneA] <-  pValueTmp[2,1]
		result@Pval[geneB,geneB] <-  pValueTmp[2,2]
		
		result@maxB[geneA,geneA] <-  bootMTmp[1,1]
		result@maxB[geneA,geneB] <-  bootMTmp[1,2]
		result@maxB[geneB,geneA] <-  bootMTmp[2,1]
		result@maxB[geneB,geneB] <-  bootMTmp[2,2]
	}
	if (dim(result@W)[1] == 0)
		result@W <- tableTmp
	else{
		while (dim(tableTmp)[2] != dim(result@W)[2])
			if(dim(tableTmp)[2] > dim(result@W)[2])
				result@W <- cbind(result@W,NA)
			else
				tableTmp <- cbind(tableTmp,NA)
		

	result@W <- rbind(result@W, tableTmp)	
	}
	return(result)

}