relNetworkBuildTable <- function(data=NULL, gLabelID="GeneName",sLabelID, samples=NULL, 
type="Rpearson", processType="B", geneA=NULL, geneB=NULL,genes=NULL, ...) {


    ## Doing a simple test...
    if(is.null(data))
        stop("The data MUST be specified!!!")
    
    if(!(type %in% c("Rpearson", "pearson", "kendall", "spearman", "MI")))
        stop("Parameter 'type' must be 'Rpearson', 'pearson', 'kendall',
        'spearman' or 'MI'.")
		
	
	if(is.null(genes))
		stop("You must enter a valid list of genes")
	
	allGenes <- getLabels(data, gLabelID, FALSE)
	allGenes[data@BadSpots] <- paste(allGenes[data@BadSpots], "(*)")
	allSamples <- getLabels(data, sLabelID)
	

	if(processType == "B") {
		##  Getting the first 2 sample types to use in case of NULL samples parameter
	    if(is.null(samples))
			samples <- unique(allSamples)[1]
	    
	    
	    ## Finding indexes of the samples specified and respective lengths
	    idxTmp <- allSamples %in% samples
	}
	else {
		 if(is.null(samples)) {
	        samples <- list(unique(allSamples)[1], unique(allSamples)[2])
	        names(samples) <- unique(allSamples)[1:2]
	    }
	    ## Finding indexes of the samples specified and respective lengths
	    idxTmp <- allSamples %in% c(samples[[1]], samples[[2]])
	}
	
		
	## Constructing the table to be used
    table <- calcW(data)
	
	table <- table[, idxTmp]
	 sTypes <- allSamples[idxTmp]

	
	tableTmp = NULL
	## Construct the table with 2 genes each time
	if(is.null(geneA) & is.null(geneB)){
		## Constructing the table to be used, averaging eventual replicates...
	    for(i in unique(genes)) {
	        idx <- allGenes %in% i
	        if(sum(idx) > 1)
	            tableTmp <- rbind(tableTmp, apply(table[idx, ], 2, mean,
	            na.rm=TRUE))
	        
	        else
	            tableTmp <- rbind(tableTmp, table[idx, ])
	    }
		## Naming tableTmp
	    rownames(tableTmp) <- unique(genes)
	    colnames(tableTmp) <- sTypes
	
	}
	else if(!is.null(geneA) & !is.null(geneB)){
		idx <- allGenes %in% geneA
		if(sum(idx) > 1)
			tableTmp <- rbind(tableTmp, apply(table[idx, ], 2, mean,
			na.rm=TRUE))
		
		else
			tableTmp <- rbind(tableTmp, table[idx, ])
			
		idx <- allGenes %in% geneB
		if(sum(idx) > 1)
			tableTmp <- rbind(tableTmp, apply(table[idx, ], 2, mean,
			na.rm=TRUE))?index
		
		else	
			tableTmp <- rbind(tableTmp, table[idx, ])
			
			
		## Naming tableTmp
		id <- genes %in% c(geneA,geneB)
	    rownames(tableTmp) <- unique(genes[id])
	    colnames(tableTmp) <- sTypes
		
		if (processType == "M"){
			colnames(tableTmp)[sTypes %in% samples[[1]]] <- names(samples)[1]
			colnames(tableTmp)[sTypes %in% samples[[2]]] <- names(samples)[2]}
	}	
	else
		stop("Enter two genes or leave both NULL!!")
		
			
		return(tableTmp)
}	

